/*
	This code is part of the MCJoin project.
	Authored by Steven Begley (sbegley@latrobe.edu.au) as part of my PhD candidature.
	La Trobe University,
	Melbourne, Australia.
*/
#pragma once

#include "DataTypes.h"
#include <iostream>

using namespace std;

struct SMetrics
{
	SMetrics() : output_cardinality(0), time_total(0), time_flipFlop_r(0), time_flipFlop_s(0), time_scatter(0), time_join(0), time_restitch(0), r_bias(0), r_chunksProcessed(0), s_chunksProcessed(0)
	{

	}

	friend ostream& operator<<(ostream& os, const SMetrics& m);

	uint64 output_cardinality;
	double time_total;
	double time_flipFlop_r;
	double time_flipFlop_s;
	double time_scatter;
	double time_join;
	double time_restitch;	// included in time_join;
	double r_bias;
	uint32 r_chunksProcessed;
	uint32 s_chunksProcessed;
};