/*
	This code is part of the MCJoin project.
	Authored by Steven Begley (sbegley@latrobe.edu.au) as part of my PhD candidature.
	La Trobe University,
	Melbourne, Australia.
*/
#pragma once
#include <chrono>

class Timer
{
public:
	Timer() : _elapsedTime(0)
	{
		_currentTime = std::chrono::high_resolution_clock::now();
		_previousTime = _currentTime;
	}

	~Timer()
	{
	}

	void update()
	{
		_currentTime = std::chrono::high_resolution_clock::now();
		_elapsedTime = std::chrono::duration_cast<std::chrono::microseconds>(_currentTime - _previousTime);
		_previousTime = _currentTime;
	}

	double getElapsedTime()
	{
		return _elapsedTime.count() / 1000000.0;
	}

private:
	std::chrono::high_resolution_clock::time_point _currentTime;
	std::chrono::high_resolution_clock::time_point _previousTime;
	std::chrono::microseconds _elapsedTime;
};